byte leds = 0;                // A kiírandó LED bitminta tárolója
const byte LED_pin[] = {10, 11, 12, 13};
void setup() {
  for (int i = 0; i < 4; i++) {
    pinMode(LED_pin[i], OUTPUT);    // LED kimenet inicializálás
    digitalWrite(LED_pin[i], HIGH); // kezdetben kikapcsolva
  }
  pinMode(4, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  digitalWrite(4, LOW);
  shiftOut(8, 7, MSBFIRST, 0xFF);
  shiftOut(8, 7, MSBFIRST, 0xF0);
  digitalWrite(4, HIGH);
}

void loop() {
  leds = 0;                   // Kezdetben minden LED kikapcsolva
  update_LEDs();              // Kijelzés frissítése
  delay(500);
  for (int i = 0; i < 4; i++) // Egyenként felkapcsoljuk a LED-eket
  {
    bitSet(leds, i);          // A 'leds' következő bitjét '1'-b állítja
    update_LEDs();            // Kijelzés frissítése
    delay(500);
  }
}

void update_LEDs() {
  for (int i = 0; i < 4; i++) {
    digitalWrite(LED_pin[i], !bitRead(leds, i));
  }
}
